;##################################################################
;
;   ZMercury (Saved data)
;
;   Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;        
;   Copyright 2011 by Patrick Davidson.  This software may be freely
;   modified and/or copied with no restrictions.  There is no warranty.
;
;   This file was last updated August 1, 2011.
;
;##################################################################

perm_vars:
saved_flag:
        .db     0               ; set if saved game

;############## Variables not zeroed on game start

game_timer:
        .dw     0
terrain_count:
        .db     0               ; position in terrain buffer
terrain_x:
        .db     0               ; terrain block number (last entered)

player_y:
        .db     0
player_x:
        .db     0

shield: .db     0,0

column_list:
        .db     0,0,0,0,0,0,0,0,0,0,0,0,0
#ifndef NARROW
        .db     0,0,0,0
#endif

;############## Variables that are zeroed on game start

zero_start:

game_status:
        .db     0               ; 0 = normal
                                ; 1 = scroll stars only (until enemies dead)
                                ; 2 = no scrolling (until enemies dead)

weapon_upgrade:
        .db     0

#define SCORELEN 3
score:  .db     0,0,0
player_bullets: ; 13 entries of size 8 = 52 words = 4 * 13
        .dw     0,0,0,0,0,0,0,0,0,0,0,0,0
        .dw     0,0,0,0,0,0,0,0,0,0,0,0,0
        .dw     0,0,0,0,0,0,0,0,0,0,0,0,0
        .dw     0,0,0,0,0,0,0,0,0,0,0,0,0
enemy_bullets:  ; 12 entries of size 8 = 48 words = 3 * 16
        .dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        .dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        .dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
e_array:        ; 12 entries of size 10 = 60 words = 4 * 15
        .dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        .dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        .dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        .dw     0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
difficulty_level:
        .db     0
bonus_count:
        .db     0               ; number of remaining bonus weapon shots
zero_end:

scores:
#ifdef NARROW
#define NAMELEN 12
        .db     "Patrick D!  ",0
        .db     $01,$60,$00
        .db     "no one      ",0
        .db     $00,$80,$00
        .db     "no one      ",0
        .db     $00,$40,$00
        .db     "no one      ",0
        .db     $00,$20,$00
        .db     "no one      ",0
        .db     $00,$10,$00
        .db     "no one      ",0
        .db     $00,$05,$00
        .db     "no one      ",0
        .db     $00,$02,$50
#else 
#define NAMELEN 16
        .db     "Patrick Davidson",0
        .db     $01,$60,00
        .db     "no one          ",0
        .db     $00,$80,00
        .db     "no one          ",0
        .db     $00,$40,00
        .db     "no one          ",0
        .db     $00,$20,00
        .db     "no one          ",0
        .db     $00,$10,00
        .db     "no one          ",0
        .db     $00,$05,00
        .db     "no one          ",0
        .db     $00,$02,50
#endif
scores_end:

#define ENTRYLEN (NAMELEN+SCORELEN+1)

perm_vars_end:
